let
  pkgs = import <nixpkgs> {
    crossSystem = (import <nixpkgs/lib>).systems.examples.armv7l-hf-multiplatform;
    overlays = [(import (builtins.fetchTarball "https://github.com/oxalica/rust-overlay/archive/master.tar.gz"))];
  };
in
  pkgs.mkShell {
    packages = with pkgs.buildPackages; [
      rust-analyzer      
    ];

    nativeBuildInputs = with pkgs.buildPackages; [
      (rust-bin.stable.latest.default.override {
        extensions = [ "rust-src" ];
        targets = [ "thumbv7em-none-eabihf" ];
      })
    ];

    env = {
      CARGO_TARGET_AARCH64_UNKNOWN_LINUX_GNU_LINKER = "${pkgs.stdenv.cc.targetPrefix}cc";
    };
  }
